searchNodes=[{"doc":"LogicalFile One file from many LogicalFile is a way of creating a logical representation of a unit of lines of text (e.g. a source code file) supplied by one or more backing files, presumably separate files on disk. It also provides for a system of macros that can transform the logical text. A typical use case for LogicalFile would be to implement a compiler that has #include style functionality. The compiler works on the whole text but can translate logical line numbers back to specific files and local line numbers (for example when an error occurs it can pinpoint the specific file and line the error arose in).","ref":"LogicalFile.html","title":"LogicalFile","type":"module"},{"doc":"assemble/2 returns a LogicalFile composed of the Section s specified in the second argument. This is mainly intended for internal use when modifying a LogicalFile during macro processing.","ref":"LogicalFile.html#assemble/2","title":"LogicalFile.assemble/2","type":"function"},{"doc":"contains_source?/2 returns true if at least one section from the given LogicalFile originates from the specified source_path . Examples iex&gt; file = LogicalFile . read ( &quot;test/support&quot; , &quot;main.source&quot; ) iex&gt; assert not LogicalFile . contains_source? ( file , &quot;test/support/player.source&quot; ) iex&gt; assert LogicalFile . contains_source? ( file , &quot;test/support/main.source&quot; )","ref":"LogicalFile.html#contains_source?/2","title":"LogicalFile.contains_source?/2","type":"function"},{"doc":"insert/3 inserts a new Section into the LogicalFile at the specified logical line number at_line and containing the contents of the source_path . It guarantees that all sections and the logical file remains contiguous. Examples","ref":"LogicalFile.html#insert/3","title":"LogicalFile.insert/3","type":"function"},{"doc":"last_line_number/1 returns the line number of the last line in the specified LogicalFile . Examples iex&gt; alias LogicalFile.Section iex&gt; file = LogicalFile . read ( &quot;test/support&quot; , &quot;main.source&quot; ) iex&gt; assert 11 = LogicalFile . last_line_number ( file )","ref":"LogicalFile.html#last_line_number/1","title":"LogicalFile.last_line_number/1","type":"function"},{"doc":"line/2 returns the specified logical line number from the LogicalFile at lno . Example iex&gt; file = LogicalFile . read ( &quot;test/support&quot; , &quot;main.source&quot; ) iex&gt; assert &quot;%(include.source)&quot; = LogicalFile . line ( file , 6 )","ref":"LogicalFile.html#line/2","title":"LogicalFile.line/2","type":"function"},{"doc":"lines/1 returns a list of all lines in the LogicalFile in line number order.","ref":"LogicalFile.html#lines/1","title":"LogicalFile.lines/1","type":"function"},{"doc":"lines/2 takes a LogicalFile and a range of logical line numbers and returns a list of tuples in the form {file, line} for the corresponding lines.","ref":"LogicalFile.html#lines/2","title":"LogicalFile.lines/2","type":"function"},{"doc":"partition_sections/2 accepts a list of Section s and a logical line number at_line representing an insertion point. It returns a tuple {sections_before, insert_section, sections_after} by finding the Section containing at_line and partitioning the remaining Section s around it.","ref":"LogicalFile.html#partition_sections/2","title":"LogicalFile.partition_sections/2","type":"function"},{"doc":"read/3 returns a new LogicalFile containing Section s that represent the contents of the file specified by source_path relative to base_path and as modified by the macros it is initialised with. Macros should implement the LogicalFile.Macro behaviours and should be specified as a list of tuples of the form {module, [options keyword list]} . See LogicalFile.Macro for further details. Examples iex&gt; file = LogicalFile . read ( &quot;test/support&quot; , &quot;main.source&quot; ) iex&gt; assert 11 = LogicalFile . size ( file )","ref":"LogicalFile.html#read/3","title":"LogicalFile.read/3","type":"function"},{"doc":"resolve_line/2 takes a logical line number logical_lno and returns a tuple {file, local_line_no} representing the file and file line number that logical line represents. Examples iex&gt; alias LogicalFile.Macros.Include iex&gt; file = LogicalFile . read ( &quot;test/support&quot; , &quot;main.source&quot; ) iex&gt; assert { &quot;test/support/main.source&quot; , 1 } = LogicalFile . resolve_line ( file , 1 )","ref":"LogicalFile.html#resolve_line/2","title":"LogicalFile.resolve_line/2","type":"function"},{"doc":"section_including_line/2 returns the Section that contains the logical line lno . Examples iex&gt; alias LogicalFile.Section iex&gt; section1 = Section . new ( &quot;test/support/main.source&quot; ) iex&gt; section2 = Section . new ( &quot;test/support/include.source&quot; ) |&gt; Section . shift ( Section . size ( section1 ) ) iex&gt; map = LogicalFile . assemble ( &quot;test/support&quot; , [ section1 , section2 ] ) iex&gt; assert ^ section1 = LogicalFile . section_including_line ( map , section1 . range . first ) iex&gt; assert ^ section2 = LogicalFile . section_including_line ( map , section2 . range . first )","ref":"LogicalFile.html#section_including_line/2","title":"LogicalFile.section_including_line/2","type":"function"},{"doc":"sections_in_order/1 takes the Section s backing a LogicalFile and returns them as a list, ordered by the range of logical line numbers they represent.","ref":"LogicalFile.html#sections_in_order/1","title":"LogicalFile.sections_in_order/1","type":"function"},{"doc":"sections_to_map/1 takes a list of Section s and returns a Map whose keys are the logical line number ranges of the sections, mapped to the corresponding sections.","ref":"LogicalFile.html#sections_to_map/1","title":"LogicalFile.sections_to_map/1","type":"function"},{"doc":"size/1 returns the number of lines in the LogicalFile . Examples iex&gt; file = LogicalFile . read ( &quot;test/support&quot; , &quot;main.source&quot; ) iex&gt; 11 = LogicalFile . size ( file )","ref":"LogicalFile.html#size/1","title":"LogicalFile.size/1","type":"function"},{"doc":"update_line/3 replaces the content of line lno in the specified LogicalFile by passing the current contents of the line to the specified transformation function. This function is expected to return the new contents of the line. Examples iex&gt; assert &quot; &quot; = ...&gt; LogicalFile . read ( &quot;test/support&quot; , &quot;main.source&quot; ) ...&gt; |&gt; LogicalFile . update_line ( 6 , fn line -&gt; String . duplicate ( &quot; &quot; , String . length ( line ) ) end ) ...&gt; |&gt; LogicalFile . line ( 6 )","ref":"LogicalFile.html#update_line/3","title":"LogicalFile.update_line/3","type":"function"},{"doc":"","ref":"LogicalFile.html#t:t/0","title":"LogicalFile.t/0","type":"type"},{"doc":"A Macro represents a LogicalFile transformation. Each Macro is implemented by a module through the apply_macro callback with zero or more arguments in a keyword list. A ' Macro invocation' is specified as a tuple in the form {module, [options keyword list]} . A macro is called through the apply_macro callback which takes a LogicalFile and returns a possibly transformed LogicalFile . The macro processor applies macros in turn to a base LogicalFile and each macro is expected to return a valid LogicalFile . Sample macro implementations are provided for handling file includes ( LogicalFile.Macros.Include ) and single-line comments ( LogicalFile.Macros.LineComment ).","ref":"LogicalFile.Macro.html","title":"LogicalFile.Macro","type":"behaviour"},{"doc":"perform macro behaviour on a LogicalFile","ref":"LogicalFile.Macro.html#c:apply_macro/2","title":"LogicalFile.Macro.apply_macro/2","type":"callback"},{"doc":"apply_macros/2 takes a LogicalFile and a list of macro invocations and applies each macro to transform the LogicalFile .","ref":"LogicalFile.Macro.html#apply_macros/2","title":"LogicalFile.Macro.apply_macros/2","type":"function"},{"doc":"generate macro invocation","ref":"LogicalFile.Macro.html#c:invocation/1","title":"LogicalFile.Macro.invocation/1","type":"callback"},{"doc":"A sample implementation of a macro that provides 'include file' functionality. It uses a regular expression to identiy include directives and inserts the contents of an included file into the LogicalFile at the appropriate place. It supports included files also including other files.","ref":"LogicalFile.Macros.Include.html","title":"LogicalFile.Macros.Include","type":"module"},{"doc":"The general strategy is to work section-by-section. Where a section includes a line that matches the macro expression (which must have a file named capture to indicate the file to be included) the line is replaced with blanks, the file is inserted, and the search is restarted on the existing section (that could have more than one include), otherwise it is restarted using the next section.","ref":"LogicalFile.Macros.Include.html#process_includes/3","title":"LogicalFile.Macros.Include.process_includes/3","type":"function"},{"doc":"A sample implementation of a macro that supports single-line comments where a comment expression is recognised at the beginning of a line and it transforms the entire content of that line into whitespace. Note that this does not allow a line comment to appear at the end of an expression! While a regular expression could be specified to recognise whitespace as part of the comment marker a more sophisticated implementation would allow the comment marker to appear after an expression. It is also left as an exercise to implement multi-line comments (a la C / ... /)","ref":"LogicalFile.Macros.LineComment.html","title":"LogicalFile.Macros.LineComment","type":"module"},{"doc":"The general strategy is to process sections in order. For each section find any line matching the expression and transform the entire contents of the line into whitespace.","ref":"LogicalFile.Macros.LineComment.html#process_comments/2","title":"LogicalFile.Macros.LineComment.process_comments/2","type":"function"},{"doc":"A Section represents lines of text from a backing file that represent a range of logical line numbers within a LogicalFile . Fields source_path the fully qualified file name of the backing file that the Section represents. range the range of logical line numbers the Section represents lines a list of the lines in the Section offset a value that transforms a logical line number to a local line number within the backing file. In the simple case a Section represents the entire contents of a backing file. However, a Section can be split and moved (for example when another Section is inserted within its range). Here the offset is adjusted to allow the conversion of logical line numbers to local line numbers in the backing file.","ref":"LogicalFile.Section.html","title":"LogicalFile.Section","type":"module"},{"doc":"first_line_number/1 returns the first logical line number of the specified Section .","ref":"LogicalFile.Section.html#first_line_number/1","title":"LogicalFile.Section.first_line_number/1","type":"function"},{"doc":"last_line_number/1 returns the last logical line number of the specified Section .","ref":"LogicalFile.Section.html#last_line_number/1","title":"LogicalFile.Section.last_line_number/1","type":"function"},{"doc":"line/2 returns a String containing the contents of logical line number lno which is expected to be within the range the Section represents. Examples iex&gt; alias LogicalFile.Section iex&gt; section = Section . new ( &quot;test/support/main.source&quot; ) iex&gt; assert &quot;%(include.source)&quot; = Section . line ( section , 6 )","ref":"LogicalFile.Section.html#line/2","title":"LogicalFile.Section.line/2","type":"function"},{"doc":"line_matching/2 takes a Section and either a predicate function or a regular expression and returns a tuple {logical_line_no, line} representing the first line from the Section that matches. Examples iex&gt; alias LogicalFile.Section iex&gt; section = Section . new ( &quot;test/support/main.source&quot; ) iex&gt; include = ~r/%((?&lt;file&gt;.*))/ iex&gt; assert { 6 , &quot;%(include.source)&quot; } = Section . line_matching ( section , fn line -&gt; String . length ( line ) &gt; 5 end ) iex&gt; assert { 6 , &quot;%(include.source)&quot; } = Section . line_matching ( section , include )","ref":"LogicalFile.Section.html#line_matching/2","title":"LogicalFile.Section.line_matching/2","type":"function"},{"doc":"lines_matching/2 takes a Section and either a predicate function or a regular expression and returns a list of tuples of the form {logical_lno, line} for each line that matches. Examples iex&gt; alias LogicalFile.Section iex&gt; section = Section . new ( &quot;test/support/commented.source&quot; ) iex&gt; assert [ { 3 , &quot;%% nothing here&quot; } , { 6 , &quot;%% or here&quot; } ] = Section . lines_matching ( section , fn line -&gt; ...&gt; String . starts_with? ( line , &quot;%%&quot; ) ...&gt; end ) iex&gt; assert [ { 1 , &quot;one&quot; } , { 2 , &quot;two&quot; } , { 8 , &quot;six&quot; } ] = Section . lines_matching ( section , fn line -&gt; String . length ( line ) &lt; 4 end )","ref":"LogicalFile.Section.html#lines_matching/2","title":"LogicalFile.Section.lines_matching/2","type":"function"},{"doc":"new/1 creates a new Section representing lines from the specified file. new/4 creates a new Section representing the contents of the file specified by source_path and representing a particular range of logical line numbers and their offset new/4 for more information. a range of lines with an offset. he offset determines how the line numbers in the range are converted into lines in the source file. For example if the offset is -5 then line 10 will correspond to line 5 of the source file. Examples iex&gt; alias LogicalFile.Section iex&gt; section = Section . new ( &quot;test/support/main.source&quot; ) iex&gt; assert &quot;test/support/main.source&quot; = section . source_path iex&gt; assert 11 = Section . size ( section ) iex&gt; assert 1 .. 11 = section . range iex&gt; assert 0 = section . offset iex&gt; alias LogicalFile.Section iex&gt; % Section { source_path : source_path , range : range , lines : lines } = ...&gt; Section . new ( &quot;foo.source&quot; , 1 .. 6 , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; , &quot;four&quot; , &quot;five&quot; , &quot;six&quot; ] ) iex&gt; assert &quot;foo.source&quot; = source_path iex&gt; assert 1 .. 6 = range iex&gt; assert 6 = Enum . count ( lines ) iex&gt; alias LogicalFile.Section iex&gt; % Section { offset : offset } = Section . new ( &quot;foo.source&quot; , 1 .. 2 , [ &quot;one&quot; , &quot;two&quot; ] , - 7 ) iex&gt; assert - 7 = offset iex&gt; alias LogicalFile.Section iex&gt; assert_raise ( RuntimeError , fn -&gt; ...&gt; % Section { } = ...&gt; Section . new ( &quot;foo.source&quot; , 1 .. 5 , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; , &quot;four&quot; ] ) ...&gt; end )","ref":"LogicalFile.Section.html#new/1","title":"LogicalFile.Section.new/1","type":"function"},{"doc":"","ref":"LogicalFile.Section.html#new/4","title":"LogicalFile.Section.new/4","type":"function"},{"doc":"resolve_line/2 takes a Section and a logical line number line that is expected to be within the range of the Section and returns a tuple {file, line} representing the file backing the Section and the corresponding local line number within the Section number Maps a line number coming from a source map that may include many sections into a line number relative to the section. For example a section may represent source included from another file. E.g. File 1 contains 20 lines &amp; File 2 contains 10 lines if we insert File 2 we get a structure like: Lines 1..10 =&gt; File 1: Lines 1..10 Lines 11..20 =&gt; File 2: Lines 1..10 Lines 21..30 =&gt; File 1: Lines 11..20 If we ask for line 15 this maps to File 2, line 5. This means file 2 is offset from the map by -10. If we ask for line 25 this maps to file 1 line 15, again offset by -10. Examples iex&gt; alias LogicalFile.Section iex&gt; section = ...&gt; Section . new ( &quot;test/support/main.source&quot; ) ...&gt; |&gt; Section . set_range ( 21 .. 30 ) ...&gt; |&gt; Section . set_offset ( - 10 ) iex&gt; assert { &quot;test/support/main.source&quot; , 15 } = Section . resolve_line ( section , 25 )","ref":"LogicalFile.Section.html#resolve_line/2","title":"LogicalFile.Section.resolve_line/2","type":"function"},{"doc":"set_offset/2 replaces the line number offset of the specified Section .","ref":"LogicalFile.Section.html#set_offset/2","title":"LogicalFile.Section.set_offset/2","type":"function"},{"doc":"set_range/2 replaces the logical line number range of the specified Section .","ref":"LogicalFile.Section.html#set_range/2","title":"LogicalFile.Section.set_range/2","type":"function"},{"doc":"shift/2 takes a Section and a number of lines to offset the section by_lines and returns a new Section containing the same lines with the logical line number range and offset shifted appropriately. Examples iex&gt; alias LogicalFile.Section iex&gt; section = ...&gt; Section . new ( &quot;foo.source&quot; , 1 .. 4 , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; , &quot;four&quot; ] ) ...&gt; |&gt; Section . shift ( 10 ) iex&gt; assert 11 .. 14 = section . range iex&gt; assert - 10 = section . offset","ref":"LogicalFile.Section.html#shift/2","title":"LogicalFile.Section.shift/2","type":"function"},{"doc":"size/1 returns the number of lines in the specified Section . Examples iex&gt; alias LogicalFile.Section iex&gt; section = Section . new ( &quot;foo.source&quot; , 1 .. 4 , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; , &quot;four&quot; ] ) iex&gt; assert 4 = Section . size ( section )","ref":"LogicalFile.Section.html#size/1","title":"LogicalFile.Section.size/1","type":"function"},{"doc":"split/2 takes a Section and a logical line number at_line expected to be within the Section and returns a tuple {before_section, after_section} derived by splitting the contents of the Section at the specified line. The before_section contains all lines up to the specified line, the after_section contains all lines from the specified line to the end of the Section . Examples iex&gt; alias LogicalFile.Section iex&gt; section = Section . new ( &quot;foo.source&quot; , 1 .. 6 , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; , &quot;four&quot; , &quot;five&quot; , &quot;six&quot; ] ) iex&gt; { % Section { } = first , % Section { } = second } = Section . split ( section , 4 ) iex&gt; assert &quot;foo.source&quot; = first . source_path iex&gt; assert 1 .. 3 = first . range iex&gt; assert [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; ] = first . lines iex&gt; assert &quot;foo.source&quot; = second . source_path iex&gt; assert 4 .. 6 = second . range iex&gt; assert [ &quot;four&quot; , &quot;five&quot; , &quot;six&quot; ] = second . lines iex&gt; alias LogicalFile.Section iex&gt; assert_raise ( RuntimeError , fn -&gt; ...&gt; section = Section . new ( &quot;foo.source&quot; , 1 .. 4 , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; , &quot;four&quot; ] ) ...&gt; Section . split ( section , 0 ) ...&gt; end )","ref":"LogicalFile.Section.html#split/1","title":"LogicalFile.Section.split/1","type":"function"},{"doc":"","ref":"LogicalFile.Section.html#split/2","title":"LogicalFile.Section.split/2","type":"function"},{"doc":"splittable?/1 takes a Section and determines whether it is splittable. In general it's not splittable if it contains only one line. Examples iex&gt; alias LogicalFile.Section iex&gt; section1 = Section . new ( &quot;bar.source&quot; , 1 .. 1 , [ &quot;one&quot; ] ) iex&gt; section2 = Section . new ( &quot;foo.source&quot; , 1 .. 2 , [ &quot;one&quot; , &quot;two&quot; ] ) iex&gt; assert not Section . splittable? ( section1 ) iex&gt; assert Section . splittable? ( section2 )","ref":"LogicalFile.Section.html#splittable?/1","title":"LogicalFile.Section.splittable?/1","type":"function"},{"doc":"total_size/1 returns the number of lines contained in the given list of Section s. Examples iex&gt; alias LogicalFile.Section iex&gt; section1 = Section . new ( &quot;foo.source&quot; , 1 .. 4 , [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; , &quot;four&quot; ] ) iex&gt; section2 = Section . new ( &quot;bar.source&quot; , 5 .. 7 , [ &quot;alpha&quot; , &quot;beta&quot; , &quot;delta&quot; ] ) iex&gt; assert 7 = Section . total_size ( [ section1 , section2 ] )","ref":"LogicalFile.Section.html#total_size/1","title":"LogicalFile.Section.total_size/1","type":"function"},{"doc":"update_line/3 takes a Section a logical number number expected to be within the Section and a function. It replaces that line with the result of calling the function with the existing line. Examples iex&gt; alias LogicalFile.Section iex&gt; section = Section . new ( &quot;test/support/main.source&quot; ) ...&gt; |&gt; Section . update_line ( 6 , fn line -&gt; String . duplicate ( &quot; &quot; , String . length ( line ) ) end ) iex&gt; assert &quot; &quot; = Section . line ( section , 6 )","ref":"LogicalFile.Section.html#update_line/3","title":"LogicalFile.Section.update_line/3","type":"function"}]